"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NestjsMicroservicesCqrs = void 0;
const common_1 = require("@nestjs/common");
const microservices_1 = require("@nestjs/microservices");
const server_factory_1 = require("@nestjs/microservices/server/server-factory");
const client_proxy_1 = require("@nestjs/microservices/client/client-proxy");
const rxjs_1 = require("rxjs");
class SubscribableClientProxy extends client_proxy_1.ClientProxy {
}
let NestjsMicroservicesCqrs = class NestjsMicroservicesCqrs {
    run(messagePatterns) {
        if (!this.client) {
            this._createClient(messagePatterns);
        }
    }
    init(options, fromBeginningConfig) {
        return this._createServer(options, fromBeginningConfig || options);
    }
    ;
    _createServer(options, fromBeginningConfig) {
        this.options = options;
        const server = server_factory_1.ServerFactory.create(options);
        const fromBeginningServer = server_factory_1.ServerFactory.create(fromBeginningConfig);
        const serverListen = server.listen;
        const tempListen = (callback) => __awaiter(this, void 0, void 0, function* () {
            yield fromBeginningServer.listen(callback);
            if (this.client && this.client.connect) {
                yield this.client.connect();
            }
            yield serverListen.bind(server)(callback);
        });
        server.listen = tempListen;
        this.server = server;
        this.fromBeginningServer = fromBeginningServer;
        this.client = undefined;
        return { strategy: server };
    }
    _createClient(messagePatterns) {
        const client = microservices_1.ClientProxyFactory.create(this.options);
        if (client) {
            if (typeof client.subscribeToResponseOf === 'function') {
                messagePatterns.forEach(message => client.subscribeToResponseOf(message));
            }
            this.client = client;
        }
    }
    addHandler(pattern, handler) {
        if (this.fromBeginningServer) {
            let oldHandler;
            oldHandler = this.fromBeginningServer.getHandlerByPattern(pattern);
            let finalHandler;
            if (!(oldHandler && oldHandler.isGlobal)) {
                finalHandler = (data, ctx) => {
                    let res;
                    if (oldHandler instanceof Function) {
                        res = oldHandler(data, ctx);
                    }
                    const res2 = handler(pattern, data.value);
                    return Promise.resolve(res2);
                };
                finalHandler.isEventHandler = true;
                finalHandler.isGlobal = true;
                this.fromBeginningServer.addHandler(pattern, finalHandler, true);
            }
        }
    }
    emit(pattern, data) {
        if (this.client) {
            return this.client.emit(pattern, data).toPromise();
        }
        return null;
    }
    send(pattern, data) {
        if (this.client) {
            return this.client.send(pattern, data);
        }
        return rxjs_1.of(null);
    }
};
NestjsMicroservicesCqrs = __decorate([
    common_1.Injectable()
], NestjsMicroservicesCqrs);
exports.NestjsMicroservicesCqrs = NestjsMicroservicesCqrs;
